clear;
matlabpool open
N_ltc=30;  % it should be equal to sqrt(N_eig)
N_eig=900;
N_par=900;

interval = 1/N_par; 
res=zeros(N_eig,N_par);
tic
parfor loop=1 : N_par 
     ham_real=zeros(N_eig,N_eig);
     alpha=loop*interval*2*3.141592653589793; 

	for i = 1 : N_eig-1 

		y=  fix((i-1)/N_ltc);    
        x= (i-1) - y * N_ltc;
		if (x<N_ltc-1) 
			
			ham_real(i,i+1)=cos(-alpha*y/2);
			ham_real(i+1,i)=cos(alpha*y/2);
        end
		if (y < (N_ltc-1) )			
			ham_real(i,i+N_ltc)=cos(alpha*x/2);
			ham_real(i+N_ltc,i)=cos(-alpha*x/2);
        end
    end
        
   res(:,loop)=eig(ham_real);
          
 end
 toc

 plot(res','k.','MarkerSize',1);
 matlabpool close;